 <!DOCTYPE html>
<html lang="en">
<head>
    <title>Train</title>
<script src="jquery-1.11.2.min.js"></script>
<script src="convnet-min.js"></script>
<script src="convnet.js"></script>
</head>
<body>
<input id="buttondj" value="save network snapshot as JSON" onclick="dump_json();" type="submit">
 <textarea id="dumpjson"></textarea>
 <script>


 var google_fonts = [
    'Droid Sans', 'Philosopher', 'Alegreya Sans', 'Chango', 'Coming Soon', 'Allan', 'Cardo', 'Bubbler One', 'Bowlby One SC',
    'Prosto One', 'Rufina', 'Cantora One', 'Denk One', 'Play', 'Architects Daughter',
    'Nova Square', 'Inder', 'Gloria Hallelujah', 'Telex', 'Comfortaa', 'Merienda',
    'Boogaloo', 'Krona One', 'Orienta', 'Sofadi One', 'Source Sans Pro', 'Revalia',
    'Overlock', 'Kelly Slab', 'Rye', 'Lato', 'Milonga', 'Aladin', 'Audiowide', 'Italiana',
    'Michroma', 'Cabin Condensed', 'Jura', 'Marko One', 'PT Mono', 'Bubblegum Sans',
    'Amaranth'
]
WebFont.load({
    google: {
        families: google_fonts
    },
    active: function() {
        fonts = fonts.concat(google_fonts)
    }
})
var layer_defs,
    net,
    trainer;

//Class
var symbols = [
    'a', 'A', 'b', 'B', 'Cc', 'd', 'D',
    'e', 'E', 'f', 'F', 'g9', 'G6', 'h', 'H',
    'iI1l', 'Jj', 'k', 'K', 'L', 'm', 'M', 'n', 'N', 'Oo0',
    'Pp', 'q', 'Q', 'r', 'R', 'Ss5', 't', 'T', 'Uu', 'vV',
    'Ww', 'Xx', 'Yy', 'Zz2', '3', '4', '7', '8',
];
var startTime = Date.now()


function r(range) {
    return 2 * (Math.random() - 0.5) * range
}

 //FONT for training
var common_fonts = [
    'Helvetica', 'Helvetica Neue', 'Arial', 'Verdana', 'Arial Black', 'Arial Narrow',
    'Myriad Pro', 'Segoe UI', 'Tahoma', 'Trebuchet MS',
    'Times New Roman', 'Garamond', 'Futura',
    'Courier', 'Courier New',  'Menlo','Comic Sans MS'
]
var fonts = [
    'Helvetica', 'Helvetica Neue', 'Arial', 'Verdana', 'Arial Black', 'Arial Narrow',
    'Myriad Pro', 'Segoe UI', 'Tahoma', 'Trebuchet MS',
    'Times New Roman', 'Garamond', 'Futura',
    'Courier', 'Courier New',  'Menlo','Comic Sans MS',
    'Comic Neue','Chalkboard', 'Comic Neue Angular', 'Tekton Pro',
    'Source Sans Pro',  'Avenir', 'Avenir Next', 'Gill Sans', 'Lucida Grande',
    'Athelas', 'Baskerville', 'Chaparral Pro', 'CMU Serif', 'Cochin', 'Georgia', 'Marion', 'Minion Pro', 'Palatino',
    'American Typewriter', 'Andale Mono', 'Arial Rounded',
    'Geneva',
    'Hoefler Text', 'Iowan Old Style',
    'OCR A Std',
    'Hobo Std', 'Didot',
    'Brandon Grotesque',
    'Charter',
    'DIN Alternate', 'DIN Condensed',
    'Kozuka Gothic Pro', 'Kozuka Mincho Pro', 'Letter Gothic Std', 'Marker Felt', 'Monaco',
    'Noteworthy', 'Optima', 'Prestige Elite Std', 'PT Serif', 'Seravek', 'Skia', 'STIXGeneral',
    'Superclarendon', 'Thonburi', 'Adobe Caslon Pro', 'Adobe Arabic'
]

fonts = fonts.concat(common_fonts).concat(common_fonts);
var etaoin = 'ZqXjQzVxKkUvJbGwYyFgOpLfWmHuDcEdPlRhBrNsIiCnMoAaStTe';

var joined = symbols.join('').split('').sort(function(b, a) {
    return etaoin.indexOf(a) - etaoin.indexOf(b)
}).join('')

symbols = symbols;
var use_validation_data = true;

var sample_test_instance = function() {
    return sample_training_instance()
}

var num_batches = 21;
var data_img_elts = new Array(num_batches);
var img_data = new Array(num_batches);
var loaded = new Array(num_batches);
var loaded_train_batches = [];
var maxmin = cnnutil.maxmin;
var f2t = cnnutil.f2t;

var draw_activations = function(elt, A, scale, grads) {
    var s = scale || 2;
    var draw_grads = false;
    if (typeof(grads) !== 'undefined') draw_grads = grads;
    var w = draw_grads ? A.dw : A.w;
    var mm = maxmin(w);
    for (var d = 0; d < A.depth; d++)
    {
        var canv = document.createElement('canvas');
        canv.className = 'actmap';
        var W = A.sx * s;
        var H = A.sy * s;
        canv.width = W;
        canv.height = H;
        var ctx = canv.getContext('2d');
        var g = ctx.createImageData(W, H);
        for (var x = 0; x < A.sx; x++)
        {
            for (var y = 0; y < A.sy; y++)
            {
                if (draw_grads)
                {
                    var dval = Math.floor((A.get_grad(x, y, d) - mm.minv) / mm.dv * 255);
                }
                else
                {
                    var dval = Math.floor((A.get(x, y, d) - mm.minv) / mm.dv * 255);
                }
                for (var dx = 0; dx < s; dx++)
                {
                    for (var dy = 0; dy < s; dy++)
                    {
                        var pp = ((W * (y * s + dy)) + (dx + x * s)) * 4;
                        for (var i = 0; i < 3; i++)
                        {
                            g.data[pp + i] = dval;
                        }
                        g.data[pp+3] = 255;
                    }
                }
            }
        }
        ctx.putImageData(g, 0, 0);
        elt.appendChild(canv);
    }
}

var paused = false;


var lossGraph = new cnnvis.Graph();
var xLossWindow = new cnnutil.Window(100);
var wLossWindow = new cnnutil.Window(100);
var trainAccWindow = new cnnutil.Window(100);
var valAccWindow = new cnnutil.Window(100);
var step_num = 0;


var dump_json = function() {
    document.getElementById("dumpjson").value = JSON.stringify(net.toJSON());
}


function sample_training_instance() {
    var letter = joined[Math.floor(joined.length * Math.random() * Math.random())];
    for (var i = 0; i < symbols.length; i++)
    {
        if (symbols[i].indexOf(letter) != -1)
        {
            var label = i;
            break;
        }
    }
    var fonfam = fonts[Math.floor(fonts.length * Math.random())]
    var ctx = document.getElementById('blah').getContext('2d');
    ctx.fillStyle = 'black'
    ctx.fillRect(0, 0, 32, 32);
    ctx.textBaseline = 'middle'
    ctx.textAlign = 'center'
    ctx.font = (100 * Math.floor(1 + 8 * Math.random())) + ' ' + (20 + r(2))+'px "'+fonfam+'"'
    ctx.fillStyle = 'white'
    ctx.save()
    ctx.translate(15 + r(1), 15 + r(1))
    ctx.rotate(r(0.1));
    ctx.fillText(letter, 0, 0);
    ctx.restore()
    var p = ctx.getImageData(0, 0, 32, 32).data;
    var x = new convnetjs.Vol(32, 32, 1, 0.0);
    var W = 32 * 32;
    for (var i = 0; i < W; i++)
    {
        x.w[i] = p[i * 4] / 255.0;
        if (Math.random() < 0.1) x.w[i] = Math.random();
    }
    x = convnetjs.augment(x, 28);
    return {
        x: x,
        label: label,
        isval: Math.random() > 0.9
    };
}

var load_and_step = function() {
    if (paused) return;
    var sample = sample_training_instance();
    step(sample);
}

var start_fun = function() {
 
    setInterval(load_and_step, 0);
}



$(window).load(function() {
   var layer_defs = [];
layer_defs.push({type:'input', out_sx:28, out_sy:28, out_depth:1});\n\
layer_defs.push({type:'conv', sx:5, filters:8, stride:1, pad:2, activation:'relu'});
layer_defs.push({type:'pool', sx:2, stride:2});
layer_defs.push({type:'conv', sx:5, filters:18, stride:1, pad:2, activation:'relu'});
layer_defs.push({type:'pool', sx:5, stride:2});
layer_defs.push({type:'softmax', num_classes:" + symbols.length + "});

net = new convnetjs.Net();
net.makeLayers(layer_defs);

trainer = new convnetjs.SGDTrainer(net, {method:'adadelta', batch_size:20, l2_decay:0.001});

    for (var k = 0; k < loaded.length; k++)
    {
        loaded[k] = false;
    }
    start_fun();
});


var dump_json = function() {
  document.getElementById("dumpjson").value = JSON.stringify(net.toJSON());
}
</script>
 </body>
</html>

